﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;

namespace SpaceMonsterRepresent.Effects
{
    class MuzzleFlash : Entity
    {
        public Image img;
        public Color color = new Color("ffff00");
        public MuzzleFlash(float x, float y, int width = 32, int height = 40, Color expColor = null, int radius = 10)
        {
            X = x + width / 2;
            Y = y;
            if(expColor != null)
            {
                color = expColor;
            }
            img = Image.CreateCircle(radius, color);
            img.CenterOrigin();
            Graphic = img;
        }
        public override void Update()
        {
            base.Update();
            img.ScaleX += 0.10f;
            img.ScaleY += 0.10f;
            img.CenterOrigin();
            img.Alpha -= 0.04f;
            if (img.Alpha <= 0)
            {
                RemoveSelf();
            }
        }
    }
}
