﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;
using SpaceMonsterRepresent.Entities.humans;
using SpaceMonsterRepresent.Entities.objects;
using SpaceMonsterRepresent.UI;
using SpaceMonsterRepresent.Scenes;

namespace SpaceMonsterRepresent.Entities
{
    class Player : Entity
    {
        private Spritemap<string> sprite;
        private static Sound death = new Sound(Assets.SFX_DEATH);
        private static Sound shoot = new Sound(Assets.SFX_SHOOT);
        private static Sound monsterDeath = new Sound(Assets.SFX_MONSTERDEATH);
        private static Sound monsterHurt = new Sound(Assets.SFX_MONSTERHURT);
        private static Sound monsterSound = new Sound(Assets.SFX_MONSTERSOUND);
        public static float speed = 2f;
        public int direction = 0;
        public int colorDurationTimer = 0;
        bool hMove = true;
        bool vMove = true;
        bool eating = false;

        public Player(float x = 0, float y = 0)
        {
            X = x;
            Y = y;
            SetHitbox(20, 30, (int)Global.Type.PLAYER);
            sprite = new Spritemap<string>(Assets.PLAYER, 46, 56);
            addNewSprites();
            sprite.Play("standDown");
            Graphic = sprite;
        }
        public override void Update()
        {
            base.Update();
            Global.PlayerX = this.X;
            Global.PlayerY = this.Y;

            if (Global.PlayerSession.Controller.Button("R").Down)
            {
                shoot.Play();
            }
            if (Global.PlayerSession.Controller.Button("A").Down || Global.PlayerSession.Controller.Button("LEFT").Down)
            {
                if (X <= -16)
                {
                    X -= 0;
                }
                else
                {
                    X -= speed;
                }
                if (!(Global.PlayerSession.Controller.Button("W").Down || Global.PlayerSession.Controller.Button("UP").Down))
                {
                    if (!eating) 
                        sprite.Play("walkLeft");
                }
                direction = Global.D_LEFT;
                hMove = true;
            }
            else if (Global.PlayerSession.Controller.Button("D").Down || Global.PlayerSession.Controller.Button("RIGHT").Down)
            {
                if (X >= Global.MW-28)
                {
                    X += 0;
                }
                else
                {
                    X += speed;
                }
                if (!(Global.PlayerSession.Controller.Button("S").Down || Global.PlayerSession.Controller.Button("DOWN").Down))
                {
                    if (!eating)
                    sprite.Play("walkRight");
                }
                direction = Global.D_RIGHT;
                hMove = true;
            }
            else
            {
                hMove = false;
            }
            if (Global.PlayerSession.Controller.Button("W").Down || Global.PlayerSession.Controller.Button("UP").Down)
            {
                if (Y <= -24)
                {
                    Y -= 0;
                }
                else
                {
                    Y -= speed;
                }
                if (!(Global.PlayerSession.Controller.Button("D").Down || Global.PlayerSession.Controller.Button("LEFT").Down))
                {
                 if(!eating)
                    sprite.Play("walkUp");
                }
                direction = Global.D_UP;
                vMove = true;
            }
            else if (Global.PlayerSession.Controller.Button("S").Down || Global.PlayerSession.Controller.Button("DOWN").Down)
            {
                if (Y >= Global.MH-42)
                {
                    Y += 0;
                }
                else
                {
                    Y += speed;
                }
                if (!(Global.PlayerSession.Controller.Button("A").Down || Global.PlayerSession.Controller.Button("RIGHT").Down))
                {
                    if (!eating)
                        sprite.Play("walkDown");
                }
                direction = Global.D_DOWN;
                vMove = true;
            }
            else
            {
                vMove = false;
            }
            stopWalkingAnimations();
            if (vMove || hMove)
            {
                //float particleXBuffer = 0;
                //float particleYBuffer = 0;
                switch (direction)
                {
                    case Global.D_UP:
                        {
                            //addparticles
                            break;
                        }
                    case Global.D_DOWN:
                        {
                            //addparticles
                            break;
                        }
                    case Global.D_LEFT:
                        {
                            //addparticles
                            break;
                        }
                    case Global.D_RIGHT:
                        {
                            //addparticles
                            break;
                        }
                }
            }
            //shoot fancy gun here
            //collisions
            var collu = Collider.Collide(X, Y - speed, (int)Global.Type.HUMAN);
            var colld = Collider.Collide(X, Y + speed, (int)Global.Type.HUMAN);
            var colll = Collider.Collide(X + speed, Y, (int)Global.Type.HUMAN);
            var collr = Collider.Collide(X - speed, Y, (int)Global.Type.HUMAN);
            var collsu = Collider.Collide(X, Y - speed, (int)Global.Type.SOLDIER);
            var collsd = Collider.Collide(X, Y + speed, (int)Global.Type.SOLDIER);
            var collsl = Collider.Collide(X + speed, Y, (int)Global.Type.SOLDIER);
            var collsr = Collider.Collide(X - speed, Y, (int)Global.Type.SOLDIER);
            var collb = Collider.Collide(X, Y, (int)Global.Type.BUSH);
            if (collb != null)
            {
                Global.PlayerIsNotInBushes = false;
            }
            else
                Global.PlayerIsNotInBushes = true;
            var collbullet = Collider.Collide(X, Y, (int)Global.Type.BULLET);
            if (collbullet != null)
            {
                Bullet b = (Bullet)collbullet.Entity;
                b.destroy();
                sprite.Color = new Color(Color.Red);
                Global.playerHealth-=2;
                monsterHurt.Play();
                colorDurationTimer = 10;
            }
            if (collu != null)
            {
                eating = true;
                RedShirt r = (RedShirt)collu.Entity;
                r.destroy();
                sprite.Play("eatUp");
            }
            if (collr != null)
            {
                eating = true;
                RedShirt r = (RedShirt)collr.Entity;
                r.destroy();
                sprite.Play("eatRight");
            }
            if (colll != null)
            {
                eating = true;
                RedShirt r = (RedShirt)colll.Entity;
                r.destroy();
                sprite.Play("eatLeft");
            }
            if (colld != null)
            {
                eating = true;
                RedShirt r = (RedShirt)colld.Entity;
                r.destroy();
                sprite.Play("eatDown");
            }
            if (collsu != null)
            {
                eating = true;
                Soldier r = (Soldier)collsu.Entity;
                r.destroy();
                sprite.Play("eatUp");
            }
            if (collsr != null)
            {
                eating = true;
                Soldier r = (Soldier)collsr.Entity;
                r.destroy();
                sprite.Play("eatRight");
            }
            if (collsl != null)
            {
                eating = true;
                Soldier r = (Soldier)collsl.Entity;
                r.destroy();
                sprite.Play("eatLeft");
            }
            if (collsd != null)
            {
                eating = true;
                Soldier r = (Soldier)collsd.Entity;
                r.destroy();
                sprite.Play("eatDown");
            }
            if (sprite.CurrentAnim == "eatRight" && sprite.CurrentFrameIndex == 7)
            {
                eating = false;
                death.Play();
                sprite.Play("standRight");
            }
            if (sprite.CurrentAnim == "eatLeft" && sprite.CurrentFrameIndex == 7)
            {
                eating = false;
                death.Play();
                sprite.Play("standLeft");
            }
            if (sprite.CurrentAnim == "eatUp" && sprite.CurrentFrameIndex == 7)
            {
                eating = false;
                death.Play();
                sprite.Play("standUp");
            }
            if (sprite.CurrentAnim == "eatDown" && sprite.CurrentFrameIndex == 7)
            {
                eating = false;
                death.Play();
                sprite.Play("standDown");
            }
            var collm = Collider.Collide(X, Y, (int)Global.Type.MOUNTAIN);
            if (collm != null)
            {
                Global.GAME.RemoveScene();
                Global.GAME.AddScene(new Cave());
            }
            var collp = Collider.Collide(X, Y, (int)Global.Type.PEDISTAL);
            if (collp != null && Global.humansEaten >= 1)
            {
                //if number is < old number.
                if (Global.HumanDestroyed)
                {
                    Global.HumanDestroyed = false;
                    Global.GAME.Scene.Add(new ScoreHuman(X, Y));
                    Global.humansEaten--;
                }
            }
            if (Global.Score >= 300)
            {
                Global.GAME.RemoveScene();
                Global.GAME.AddScene(new WinScreen());
            }
            //timers
            if (colorDurationTimer > 0) colorDurationTimer--;
            if (colorDurationTimer <= 0) sprite.Color = new Color(Color.White);
            //death
            if (Global.playerHealth <= 0)
            {
                monsterDeath.Play();
                Global.GAME.Scene.Add(new PlayerDeath(X, Y));
                destroy();
            }
        }
        public void addNewSprites()
        {
            sprite.Add("standLeft", new int[] { 15 });
            sprite.Add("standRight", new int[] { 0 });
            sprite.Add("standUp", new int[] { 24 });
            sprite.Add("standDown", new int[] { 16 });
            sprite.Add("walkLeft", new int[] { 15, 14, 13, 12, 11, 9, 8 }, new float[] { 5f, 5f });
            sprite.Add("walkRight", new int[] { 0, 1, 2, 3, 4, 5, 6, 7 }, new float[] { 5f, 5f });
            sprite.Add("walkDown", new int[] { 16, 17, 18, 19, 18, 17, 16, 20, 21, 22, 21, 20 }, new float[] { 3f, 3f });
            sprite.Add("walkUp", new int[] { 24, 25, 26, 27, 26, 25, 24, 28, 29, 30, 29, 28 }, new float[] { 3f, 3f });
            sprite.Add("eatRight", new int[] { 47, 46, 45, 44, 43, 42, 41, 40 }, new float[] { 4f, 4f });
            sprite.Add("eatLeft", new int[] { 32, 33, 34, 35, 36, 37, 38, 39 }, new float[] { 4f, 4f });
            sprite.Add("eatUp", new int[] { 57, 58, 59, 60, 61, 62, 63, 64 }, new float[] { 4f, 4f });
            sprite.Add("eatDown", new int[] { 48, 49, 50, 51, 52, 53, 54, 55 }, new float[] { 4f, 4f });
        }
        public void stopWalkingAnimations()
        {
            if (!hMove && !vMove)
            {
                switch (sprite.CurrentAnim)
                {
                    case ("walkLeft"):
                        sprite.Play("standLeft");
                        break;
                    case ("walkRight"):
                        sprite.Play("standRight");
                        break;
                    case ("walkUp"):
                        sprite.Play("standUp");
                        break;
                    case ("walkDown"):
                        sprite.Play("standDown");
                        break;
                    default:
                        break;
                }
            }
        }
        public void destroy()
        {
            RemoveSelf();
        }
    }
}
