﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;
using SpaceMonsterRepresent.Scenes;

namespace SpaceMonsterRepresent.UI
{
    class PlayerDeath : Entity
    {
        private Spritemap<string> sprite;
        private Text text;

        public PlayerDeath(float x, float y)
        {
            X = x;
            Y = y;
            text = new Text("=", 13);
            SetHitbox(20, 30, (int)Global.Type.PLAYER);
            sprite = new Spritemap<string>(Assets.PLAYERDEATH, 46, 56);
            sprite.Add("grid", new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13}, new float[] { 4f, 4f });
            sprite.Play("grid");
            Graphic = sprite;
            AddGraphic(text, 13, 0);
        }
        public override void Update()
        {
            base.Update();
            if (sprite.CurrentAnim == "grid" && sprite.CurrentFrameIndex == 13)
            {
                Global.GAME.Scene.RemoveAll();
                if (!Global.isGoal) Global.GAME.SwitchScene(new LoseScreen());
                else Global.GAME.SwitchScene(new WinScreen());
            }
        }
    }
}
