﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;
using SpaceMonsterRepresent.Scenes;

namespace SpaceMonsterRepresent.UI
{
    class ScoreHuman : Entity
    {
        public float speed = 3f;
        private Spritemap<string> sprite;
        private bool firstPass = true;
        private double angleInRadians = 1;
        private static Sound monsterSound = new Sound(Assets.SFX_MONSTERSOUND);

        public ScoreHuman(float x, float y)
        {
            X = x;
            Y = y;
            SetHitbox(20, 30, (int)Global.Type.SCOREHUMAN);
            sprite = new Spritemap<string>(Assets.REDSHIRT, 46, 56);
            sprite.Add("grid", new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 }, new float[] { 4f, 4f });
            sprite.Play("grid");
            Graphic = sprite;
        }
        public override void Update()
        {
            base.Update();
            if (firstPass)
            {
                firstPass = false;
                var vector2 = new Point((int)X, (int)Y);
                var vector1 = new Point(10, 10);
                angleInRadians = Math.Atan2(vector2.Y - vector1.Y, vector2.X - vector1.X);
                var angleInDegrees = MathHelper.ToDegrees((float)angleInRadians);
            }
            X -= speed * (float)Math.Cos(angleInRadians) * 5;
            Y -= speed * (float)Math.Sin(angleInRadians) * 5;
            var collp = Collider.Collide(X, Y, (int)Global.Type.BEAM);
            if (collp != null)
            {
                Global.Score++;
                Global.HumanDestroyed = true;
                monsterSound.Play();
                RemoveSelf();
            }
        }
    }
}
