﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;

namespace SpaceMonsterRepresent.Entities.humans
{
    class DeadHuman : Entity
    {
        private const int MIN_X_JITTER = 0;
        private const int MAX_X_JITTER = 30;

        private Text text;
        private Text backgroundText;

        public DeadHuman(float x, float y, string dmgText, int fontSize)
        {
            backgroundText = new Text(dmgText, fontSize);
            text = new Text(dmgText, fontSize);
            pickRandomColor();
            X = x + Otter.Rand.Int(MIN_X_JITTER, MAX_X_JITTER);
            Y = y + Otter.Rand.Int(1, 10);
            Graphic = backgroundText;
            AddGraphic(text);

        }
        public override void Update()
        {
            base.Update();
            backgroundText.Alpha -= 0.02f;
            text.Alpha -= 0.02f;
            Y -= Otter.Rand.Float(0.1f, 1.25f);
            if (text.Alpha <= 0)
            {
                RemoveSelf();
            }
        }
        public void pickRandomColor()
        {
            var randomInt = Otter.Rand.Int(1, 12);
            if (randomInt == 1)
                backgroundText.Color = new Color(Color.Black);
            if (randomInt == 2)
                backgroundText.Color = new Color(Color.Blue);
            if (randomInt == 3)
                backgroundText.Color = new Color(Color.Cyan);
            if (randomInt == 4)
                backgroundText.Color = new Color(Color.Gold);
            if (randomInt == 5)
                backgroundText.Color = new Color(Color.Gray);
            if (randomInt == 6)
                backgroundText.Color = new Color(Color.Green);
            if (randomInt == 7)
                backgroundText.Color = new Color(Color.Grey);
            if (randomInt == 8)
                backgroundText.Color = new Color(Color.Magenta);
            if (randomInt == 9)
                backgroundText.Color = new Color(Color.Orange);
            if (randomInt == 10)
                backgroundText.Color = new Color(Color.Red);
            if (randomInt == 11)
                backgroundText.Color = new Color(Color.White);
            if (randomInt == 12)
                backgroundText.Color = new Color(Color.Yellow);
        }
    }
}
