﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;

namespace SpaceMonsterRepresent.Entities.humans
{
    class RedShirt : Entity
    {
        private float speed = .1f;
        //private int health = 10;
        //private float moveDistance = 300;
        private const int MIN_X_JITTER = 0;
        private const int MAX_X_JITTER = 30;
        private Spritemap<string> sprite;
        private static Sound yell = new Sound(Assets.SFX_YELL);
        private static Sound death = new Sound(Assets.SFX_DEATH);
        //private bool isInside = true;
        //private bool isCollidingEnemy = false;
        private int randNumber = 1;
        private int walking = 1000;
        private bool isWalking = false;
        private bool dying = false;

        public RedShirt(float x, float y)
            : base(x, y)
        {
            SetHitbox(32, 32, (int)Global.Type.HUMAN);
            X = x + Otter.Rand.Int(MIN_X_JITTER, MAX_X_JITTER);
            Y = y + Otter.Rand.Int(1, 10);


            sprite = new Spritemap<string>(Assets.REDSHIRT, 46, 56);
            sprite.Add("standLeft", new int[] { 8 });
            sprite.Add("standRight", new int[] { 0 });
            sprite.Add("standUp", new int[] { 16 });
            sprite.Add("standDown", new int[] { 24 });
            sprite.Add("walkLeft", new int[] { 8, 9, 10, 9 }, new float[] { 10f, 10f });
            sprite.Add("walkRight", new int[] { 0, 1, 2, 1 }, new float[] { 10f, 10f });
            sprite.Add("walkUp", new int[] { 16, 17, 18, 17 }, new float[] { 10f, 10f });
            sprite.Add("walkDown", new int[] { 24, 25, 26, 25 }, new float[] { 10f, 10f });
            sprite.Add("death", new int[] { 24, 25, 26, 25, 1, 0, 2, 5, 7, 2, 9, 4, 6, 23, 6 }, new float[] { 5f, 5f });
            Graphic = sprite;
            //pickRandomColor();
            Collider.CenterOrigin();
        }

        public override void Update()
        {
            //so i need to make it so that you can't go the same general direction twice in a row?
            //so yeah. so if we are going up, we can't go upright or upleft or up next. If we are going up right, we can't go . well, just not the smae direction twice in a row.
            //if you can't go upright, up, or right, if you are going left, you can't go left, leftup or left down. maybe, we can try this. this should only happen once? then reset.
            //meaning any direction is fine after that.
            base.Update();
            if (!dying)
            {
                if (walking <= 0)
                {
                    walking = 1000;
                    isWalking = false;
                }
                walking--;
                if (!isWalking)
                    grn();
                if (isWalking)
                {
                    if (X < 16)
                    {
                        X += 0;
                    }
                    else if (X >= Global.MW)
                    {
                        X += 0;
                    }
                    else if (Y < 16)
                    {
                        Y += 0;
                    }
                    else if (Y >= Global.MH)
                    {
                        Y += 0;
                    }
                    else switch (randNumber)
                        {
                            case 1:
                                {
                                    Y -= speed;
                                    X += speed;
                                    sprite.Play("walkRight");
                                    break;
                                }
                            case 2:
                                {
                                    X += speed;
                                    sprite.Play("walkRight");
                                    break;
                                }
                            case 3:
                                {
                                    X += speed;
                                    Y += speed;
                                    sprite.Play("walkRight");
                                    break;
                                }
                            case 4:
                                {
                                    Y += speed;
                                    sprite.Play("walkDown");
                                    break;
                                }
                            case 5:
                                {
                                    Y += speed;
                                    X -= speed;
                                    sprite.Play("walkLeft");
                                    break;
                                }
                            case 6:
                                {
                                    X -= speed;
                                    sprite.Play("walkLeft");
                                    break;
                                }
                            case 7:
                                {
                                    Y -= speed;
                                    X -= speed;
                                    sprite.Play("walkLeft");
                                    break;
                                }
                            case 8:
                                {
                                    Y -= speed;
                                    sprite.Play("walkUp");
                                    break;
                                }
                        }
                }
            }
            //collisions
            var collp = Collider.Collide(X, Y, (int)Global.Type.PLAYER);
            if (collp != null)
            {
                dying = true;
                sprite.Play("death");
            }
            if (dying)
            {
                sprite.Alpha -= 0.02f;
                Y -= Otter.Rand.Float(0.1f, 1.25f);
            }
        }

        public int grn()
        {
            isWalking = true;
            return randNumber = Otter.Rand.Int(1, 9);

        }

        public void stopWalkingAnimations()
        {
            if (!isWalking)
            {
                switch (sprite.CurrentAnim)
                {
                    case ("walkLeft"):
                        sprite.Play("standLeft");
                        break;
                    case ("walkRight"):
                        sprite.Play("standRight");
                        break;
                    case ("walkUp"):
                        sprite.Play("standUp");
                        break;
                    case ("walkDown"):
                        sprite.Play("standDown");
                        break;
                }
            }
        }

        public void destroy()
        {
            Global.GAME.Scene.Add(new DeadHuman(X, Y, "AAAAA", 16));
            yell.Play();
            this.Y = Otter.Rand.Int(0, Global.MH);
            this.X = Otter.Rand.Int(0, Global.MW);
            Global.playerHealth += 2;
            Global.humansEaten++;
            //RemoveSelf();
        }
        public void pickRandomColor()
        {
            var randomInt = Otter.Rand.Int(1, 12);
            if (randomInt == 1)
                sprite.Color = new Color(Color.Black);
            if (randomInt == 2)
                sprite.Color = new Color(Color.Blue);
            if (randomInt == 3)
                sprite.Color = new Color(Color.Cyan);
            if (randomInt == 4)
                sprite.Color = new Color(Color.Gold);
            if (randomInt == 5)
                sprite.Color = new Color(Color.Gray);
            if (randomInt == 6)
                sprite.Color = new Color(Color.Green);
            if (randomInt == 7)
                sprite.Color = new Color(Color.Grey);
            if (randomInt == 8)
                sprite.Color = new Color(Color.Magenta);
            if (randomInt == 9)
                sprite.Color = new Color(Color.Orange);
            if (randomInt == 10)
                sprite.Color = new Color(Color.Red);
            if (randomInt == 11)
                sprite.Color = new Color(Color.White);
            if (randomInt == 12)
                sprite.Color = new Color(Color.Yellow);
        }
    }
}
