﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;
using SpaceMonsterRepresent.Entities.objects;
using SpaceMonsterRepresent.Effects;

namespace SpaceMonsterRepresent.Entities.humans
{
    class Soldier : Entity
    {
        private float speed = .2f;
        //private int health = 10;
        //private float moveDistance = 300;
        private const int MIN_X_JITTER = 0;
        private const int MAX_X_JITTER = 30;
        private Spritemap<string> sprite;
        private static Sound yell = new Sound(Assets.SFX_YELL);
        private static Sound soldierdeath = new Sound(Assets.SFX_SOLDIERDEATH);
        private static Sound shoot = new Sound(Assets.SFX_SHOOT);
        //private bool isInside = true;
        //private bool isCollidingEnemy = false;
        private int shootTimer = 1;
        private int randNumber = 1;
        private int walking = 1000;
        private bool isWalking = false;
        private bool dying = false;

        public Soldier(float x, float y)
            : base(x, y)
        {
            SetHitbox(32, 32, (int)Global.Type.SOLDIER);
            X = x + Otter.Rand.Int(MIN_X_JITTER, MAX_X_JITTER);
            Y = y + Otter.Rand.Int(1, 10);


            sprite = new Spritemap<string>(Assets.SOLDIER, 46, 56);
            sprite.Add("standLeft", new int[] { 8 });
            sprite.Add("standRight", new int[] { 0 });
            sprite.Add("standUp", new int[] { 16 });
            sprite.Add("standDown", new int[] { 24 });
            sprite.Add("walkLeft", new int[] { 8, 9, 10, 9 }, new float[] { 10f, 10f });
            sprite.Add("walkRight", new int[] { 0, 1, 2, 1 }, new float[] { 10f, 10f });
            sprite.Add("walkUp", new int[] { 16, 17, 18, 17 }, new float[] { 10f, 10f });
            sprite.Add("walkDown", new int[] { 24, 25, 26, 25 }, new float[] { 10f, 10f });
            sprite.Add("death", new int[] { 24, 25, 26, 25, 1, 0, 2, 5, 7, 2, 9, 4, 6, 23, 6 }, new float[] { 5f, 5f });
            Graphic = sprite;
            //pickRandomColor();
            Collider.CenterOrigin();
        }

        public override void Update()
        {
            base.Update();
            if (!dying)
            {
                if (walking <= 0)
                {
                    walking = 1000;
                    isWalking = false;
                }
                walking--;
                if (!isWalking)
                    grn();
                if (isWalking)
                {
                    if (X < 16)
                    {
                        X += 0;
                    }
                    else if (X >= Global.MW)
                    {
                        X += 0;
                    }
                    else if (Y < 16)
                    {
                        Y += 0;
                    }
                    else if (Y >= Global.MH)
                    {
                        Y += 0;
                    }
                    else switch (randNumber)
                        {
                            case 1:
                                {
                                    Y -= speed;
                                    X += speed;
                                    sprite.Play("walkRight");
                                    break;
                                }
                            case 2:
                                {
                                    X += speed;
                                    sprite.Play("walkRight");
                                    break;
                                }
                            case 3:
                                {
                                    X += speed;
                                    Y += speed;
                                    sprite.Play("walkRight");
                                    break;
                                }
                            case 4:
                                {
                                    Y += speed;
                                    sprite.Play("walkDown");
                                    break;
                                }
                            case 5:
                                {
                                    Y += speed;
                                    X -= speed;
                                    sprite.Play("walkLeft");
                                    break;
                                }
                            case 6:
                                {
                                    X -= speed;
                                    sprite.Play("walkLeft");
                                    break;
                                }
                            case 7:
                                {
                                    Y -= speed;
                                    X -= speed;
                                    sprite.Play("walkLeft");
                                    break;
                                }
                            case 8:
                                {
                                    Y -= speed;
                                    sprite.Play("walkUp");
                                    break;
                                }
                        }
                }
            }
            //collisions
            //shooting
            if (shootTimer <= 0 && Global.PlayerIsNotInBushes)
            {
                shootTimer = Otter.Rand.Int(50, 150);
                var e = new Bullet(X+20, Y+25); 
                e.Layer = 400;
                Global.GAME.Scene.Add(e);
                Global.GAME.Scene.Add(new MuzzleFlash(X+20, Y+25));
                shoot.Volume = .5f;
                shoot.Play();
            }
            shootTimer--;
        }

        public int grn()
        {
            isWalking = true;
            return randNumber = Otter.Rand.Int(1, 9);
        }

        public void stopWalkingAnimations()
        {
            if (!isWalking)
            {
                switch (sprite.CurrentAnim)
                {
                    case ("walkLeft"):
                        sprite.Play("standLeft");
                        break;
                    case ("walkRight"):
                        sprite.Play("standRight");
                        break;
                    case ("walkUp"):
                        sprite.Play("standUp");
                        break;
                    case ("walkDown"):
                        sprite.Play("standDown");
                        break;
                }
            }
        }

        public void destroy()
        {
            Global.GAME.Scene.Add(new DeadHuman(X, Y, "OUCH!", 16));
            soldierdeath.Play();
            this.Y = Otter.Rand.Int(0, Global.MH);
            this.X = Otter.Rand.Int(0, Global.MW);
            Global.playerHealth += 5;
            Global.humansEaten+=5;
            RemoveSelf();
        }
    }
}

