﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;

namespace SpaceMonsterRepresent.Entities.objects
{
    class Bullet : Entity
    {
        public float speed = 2f;
        public int direction = 0;
        public float distanceTraveled = 0f;
        public float maxDistance = 300f;
        private Spritemap<string> sprite;
        private bool firstPass = true;
        private double angleInRadians = 1;

        public Bullet(float x, float y)
        {
            X = x;
            Y = y;

            SetHitbox(2, 2, (int)Global.Type.BULLET);
            sprite = new Spritemap<string>(Assets.BULLET, 2, 2);
            sprite.Add("shoot", new int[] { 0, 1, 2, 3 }, new float[] { 5f, 5f });
            sprite.Play("shoot");
            pickRandomColor();
            Graphic = sprite;
        }
        public override void Update()
        {
            base.Update();
            if (firstPass)
            {
                firstPass = false;
                var vector2 = new Point((int)X,(int)Y);
                var vector1 = new Point((int)Global.PlayerX + 20,(int)Global.PlayerY + 25);
                //angleInRadians = Math.Atan2(vector2.Y, vector2.X) - Math.Atan2(vector1.Y, vector1.X);
                angleInRadians = Math.Atan2(vector2.Y - vector1.Y, vector2.X- vector1.X);
                var angleInDegrees = MathHelper.ToDegrees((float)angleInRadians);
            }
            Fire();
            if (distanceTraveled >= maxDistance)
            {
                destroy();
            }
            distanceTraveled += speed;
        }
        public void Fire()
		{
			X -= speed * (float)Math.Cos(angleInRadians);
			Y -= speed * (float)Math.Sin(angleInRadians);
		}
        public void pickRandomColor()
        {
            var randomInt = Otter.Rand.Int(1, 12);
            if (randomInt == 1)
                sprite.Color = new Color(Color.Black);
            if (randomInt == 2)
                sprite.Color = new Color(Color.Blue);
            if (randomInt == 3)
                sprite.Color = new Color(Color.Cyan);
            if (randomInt == 4)
                sprite.Color = new Color(Color.Gold);
            if (randomInt == 5)
                sprite.Color = new Color(Color.Gray);
            if (randomInt == 6)
                sprite.Color = new Color(Color.Green);
            if (randomInt == 7)
                sprite.Color = new Color(Color.Grey);
            if (randomInt == 8)
                sprite.Color = new Color(Color.Magenta);
            if (randomInt == 9)
                sprite.Color = new Color(Color.Orange);
            if (randomInt == 10)
                sprite.Color = new Color(Color.Red);
            if (randomInt == 11)
                sprite.Color = new Color(Color.White);
            if (randomInt == 12)
                sprite.Color = new Color(Color.Yellow);
        }
        public void destroy()
        {
            RemoveSelf();
        }
    }
}
