﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;

namespace SpaceMonsterRepresent.Entities.objects
{
    class Bush : Entity
    {
        private Spritemap<string> sprite;
        public Bush(float x = 0, float y = 0)
        {
            X = x;
            Y = y;
            SetHitbox(15, 15, (int)Global.Type.BUSH);
            sprite = new Spritemap<string>(Assets.BUSH, 50, 50);
            sprite.Add("standDown", new int[] { 0 });
            sprite.Play("standDown");
            pickRandomColor();
            Graphic = sprite;
        }
        public override void Update()
        {
            base.Update();
            var collp = Collider.Collide(X, Y, (int)Global.Type.PLAYER);
            if (collp != null)
            {
                sprite.Alpha = .5f;
            }
            else
            {
                sprite.Alpha = 1f;
            }
        }
        public void pickRandomColor()
        {
            var randomInt = Otter.Rand.Int(1, 12);
            if (randomInt == 1)
                sprite.Color = new Color(Color.Black);
            if (randomInt == 2)
                sprite.Color = new Color(Color.Blue);
            if (randomInt == 3)
                sprite.Color = new Color(Color.Cyan);
            if (randomInt == 4)
                sprite.Color = new Color(Color.Gold);
            if (randomInt == 5)
                sprite.Color = new Color(Color.Gray);
            if (randomInt == 6)
                sprite.Color = new Color(Color.Green);
            if (randomInt == 7)
                sprite.Color = new Color(Color.Grey);
            if (randomInt == 8)
                sprite.Color = new Color(Color.Magenta);
            if (randomInt == 9)
                sprite.Color = new Color(Color.Orange);
            if (randomInt == 10)
                sprite.Color = new Color(Color.Red);
            if (randomInt == 11)
                sprite.Color = new Color(Color.White);
            if (randomInt == 12)
                sprite.Color = new Color(Color.Yellow);
        }
    }
}
