﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;

namespace SpaceMonsterRepresent.Scenes
{
    class LoseScreen : Scene
    {
        public Image loseImage = new Image(Assets.LOSEIMAGE);
        public Text loseText = new Text("Nice try, you managed to get: " + Global.humansEaten + ",\n out of: " + Global.Goal + ",\n better luck next time!", 20);
        public Text enterText = new Text("Press Q to go back to title screen", 15);
        public LoseScreen()
        {
            loseImage.ScaleY = 0.80f;
            this.AddGraphic(loseImage);

            loseText.OutlineColor = new Otter.Color("ff0080");

            loseText.OutlineThickness = 3;
            loseText.CenterOrigin();
            loseText.X = Global.GAME.HalfWidth;
            loseText.Y = 155;
            this.AddGraphic(loseText);

            enterText.OutlineColor = new Otter.Color("ff0080");
            enterText.OutlineThickness = 2;
            enterText.CenterOrigin();
            enterText.X = Global.GAME.HalfWidth;
            enterText.Y = 350;
            this.AddGraphic(enterText);
            Global.player = null;
            Global.humansEaten = 0;
            Global.isGoal = false;
            Global.playerHealth = 100;
        }
        public override void Update()
        {
            base.Update();
            if ((Global.PlayerSession.Controller.Button("q").Down))
            {
                Global.GAME.RemoveScene();
                Global.GAME.AddScene(new TitleScreen());
            }
        }

    }
}
