﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;

namespace SpaceMonsterRepresent.Scenes
{
    class WinScreen : Scene
    {
        public Image winImage = new Image(Assets.WINIMAGE);
        public Text winText = new Text("You Win! You managed to ship out " + Global.humansEaten + "to your home planet and beat all the other monsters!", 20);
        public Text enterText = new Text("Press Q to go back to title screen", 15);
        public WinScreen ()
        {
            winImage.ScaleY = 0.80f;
            this.AddGraphic(winImage);

            winText.OutlineColor = new Otter.Color("ff00ff");
            winText.OutlineThickness = 3;
            winText.CenterOrigin();
            winText.X = Global.GAME.HalfWidth;
            winText.Y = 155;
            this.AddGraphic(winText);

            enterText.OutlineColor = new Otter.Color("ff00ff");
            enterText.OutlineThickness = 2;
            enterText.CenterOrigin();
            enterText.X = Global.GAME.HalfWidth;
            enterText.Y = 300;
            this.AddGraphic(enterText);
            Global.player = null;
            Global.humansEaten = 0;
            Global.isGoal = false;
            Global.playerHealth = 100;
        }
        public override void Update()
        {
            base.Update();
            if ((Global.PlayerSession.Controller.Button("q").Down))
            {
                Global.GAME.RemoveScene();
                Global.GAME.AddScene(new TitleScreen());
            }
        }

    }
}
