﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;

namespace SpaceMonsterRepresent.UI
{
    class Life : Entity
    {
        private Spritemap<string> sprite;

        private Text text;
        private Text backgroundText;

        public Life(float x, float y)
        {
            X = x;
            Y = y;
            backgroundText = new Text("Health", 12);
            text = new Text(Global.playerHealth.ToString(), 12);
            sprite = new Spritemap<string>(Assets.JAROFLIFE, 16, 16);
            addSprites();
            sprite.Play("90s");
            sprite.Color = new Color(Color.Red);
            Graphic = sprite;
            AddGraphic(backgroundText, -45, 0);
            //AddGraphic(text, 20, 0);
        }
        public override void Update()
        {
            X = this.Scene.CameraX + 50;
            Y = this.Scene.CameraY + 10;
            base.Update();
            if (Global.playerHealth <= 100 && Global.playerHealth > 90)
            {
                sprite.Play("90s");
            }
            if (Global.playerHealth <= 90 && Global.playerHealth > 80)
            {
                sprite.Play("80s");
            }
            if (Global.playerHealth <= 80 && Global.playerHealth > 70)
            {
                sprite.Play("70s");
            }
            if (Global.playerHealth <= 70 && Global.playerHealth > 60)
            {
                sprite.Play("60s");
            }
            if (Global.playerHealth <= 60 && Global.playerHealth > 50)
            {
                sprite.Play("50s");
            }
            if (Global.playerHealth <= 50 && Global.playerHealth > 40)
            {
                sprite.Play("40s");
            }
            if (Global.playerHealth <= 40 && Global.playerHealth > 30)
            {
                sprite.Play("30s");
            }
            if (Global.playerHealth <= 30 && Global.playerHealth > 20)
            {
                sprite.Play("20s");
            }
            if (Global.playerHealth <= 20 && Global.playerHealth > 10)
            {
                sprite.Play("10s");
            }
            if (Global.playerHealth <= 10 && Global.playerHealth > 0)
            {
                sprite.Play("0s");
            }
            
        }
        public void addSprites()
        {
            sprite.Add("90s", new int[] { 0 });
            sprite.Add("80s", new int[] { 1 });
            sprite.Add("70s", new int[] { 2 });
            sprite.Add("60s", new int[] { 3 });
            sprite.Add("50s", new int[] { 4 });
            sprite.Add("40s", new int[] { 5 });
            sprite.Add("30s", new int[] { 6 });
            sprite.Add("20s", new int[] { 7 });
            sprite.Add("10s", new int[] { 8 });
            sprite.Add("0s", new int[] { 9, 10, 11, 12, 11, 10 }, new float[] { 5f, 5f });
        }
        public void pickRandomColor()
        {
            var randomInt = Otter.Rand.Int(1, 12);
            if (randomInt == 1)
                sprite.Color = new Color(Color.Black);
            if (randomInt == 2)
                sprite.Color = new Color(Color.Blue);
            if (randomInt == 3)
                sprite.Color = new Color(Color.Cyan);
            if (randomInt == 4)
                sprite.Color = new Color(Color.Gold);
            if (randomInt == 5)
                sprite.Color = new Color(Color.Gray);
            if (randomInt == 6)
                sprite.Color = new Color(Color.Green);
            if (randomInt == 7)
                sprite.Color = new Color(Color.Grey);
            if (randomInt == 8)
                sprite.Color = new Color(Color.Magenta);
            if (randomInt == 9)
                sprite.Color = new Color(Color.Orange);
            if (randomInt == 10)
                sprite.Color = new Color(Color.Red);
            if (randomInt == 11)
                sprite.Color = new Color(Color.White);
            if (randomInt == 12)
                sprite.Color = new Color(Color.Yellow);
        }
    }
}
