﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;
using SpaceMonsterRepresent.Entities;

namespace SpaceMonsterRepresent.Util
{
    class Camera : Entity
    {
        private float cameraOffset;
        private float cameraSpeed;
        private float newCameraX = 0;
        private float newCameraY = 0;

        public Camera(float _cameraOffset, float _cameraSpeed)
        {
            cameraOffset = _cameraOffset;
            cameraSpeed = _cameraSpeed;
        }
        public void adjustToPlayer(int mapWidth, int mapHeight, float playerX, float playerY)
        {
            this.Scene.CenterCamera(playerX, playerY);
            newCameraX = playerX - Global.GAME.Width / 2;
            newCameraY = playerY - Global.GAME.Height / 2;

            if (newCameraX < 0) newCameraX = 0;
            if (newCameraY < 0) newCameraY = 0;
            if (newCameraX > mapWidth - Global.GAME.Width) newCameraX = mapWidth - Global.GAME.Width;
            if (newCameraX > mapHeight - Global.GAME.Height) newCameraY = mapHeight - Global.GAME.Height;
            
            this.Scene.CameraX = Math.Abs(newCameraX);
            this.Scene.CameraY = Math.Abs(newCameraY);

        }

        public void followPlayer(int mapWidth, int mapHeight, float playerX, float playerY)
        {
            if (cameraSpeed != Player.speed) cameraSpeed = Player.speed;
            if (playerX - this.Scene.CameraX < 320 + cameraOffset - cameraSpeed)//was +320 this number changes based on size of the map...
            {
                if (this.Scene.CameraX > 0) this.Scene.CameraX -= cameraSpeed;
            }
            else if ((this.Scene.CameraX + Global.GAME.Width) - playerX < 200 + cameraOffset - cameraSpeed)//was 150(inside the commented area)
            {
                if (this.Scene.CameraX + Global.GAME.Width < mapWidth) this.Scene.CameraX += cameraSpeed;
            }
            if (playerY - 180 - this.Scene.CameraY < 10 + cameraOffset - cameraSpeed)//was playerY - 120 - this.Scene.CameraY < 10 ...
            {
                if (this.Scene.CameraY > 0) this.Scene.CameraY -= cameraSpeed;
            }
            else if ((this.Scene.CameraY + Global.GAME.Height) - playerY < 90 + cameraOffset - cameraSpeed)//was 90
            {
                if (this.Scene.CameraY + Global.GAME.Height < mapHeight) this.Scene.CameraY += cameraSpeed;
            }
        }
    }
}
